/*  DEC/CMS REPLACEMENT HISTORY, Element COMPOSITEP.H */
/*   5    31-MAR-1988 11:59:51 TREGGIARI "MARCH 30 INTRINSICS" */
/*   4    24-MAR-1988 15:43:14 TREGGIARI "Replace with completely new version" */
/*  *3    27-FEB-1988 18:16:43 GEORGE "Add copyright" */
/*  *2     5-JAN-1988 15:32:40 TREGGIARI "Replace with completely new version" */
/*  *1    18-DEC-1987 14:01:50 TREGGIARI "Initial Entry" */
/*  DEC/CMS REPLACEMENT HISTORY, Element COMPOSITEP.H */
/*
* $Header: CompositeP.h,v 6.3 87/12/08 12:40:18 asente Exp $
*/

/*
*****************************************************************************
**                                                                          *
**                         COPYRIGHT (c) 1988 BY                            *
**             DIGITAL EQUIPMENT CORPORATION, MAYNARD, MASS.                *
**			   ALL RIGHTS RESERVED                              *
**                                                                          *
**  THIS SOFTWARE IS FURNISHED UNDER A LICENSE AND MAY BE USED AND  COPIED  *
**  ONLY  IN  ACCORDANCE  WITH  THE  TERMS  OF  SUCH  LICENSE AND WITH THE  *
**  INCLUSION OF THE ABOVE COPYRIGHT NOTICE.  THIS SOFTWARE OR  ANY  OTHER  *
**  COPIES  THEREOF MAY NOT BE PROVIDED OR OTHERWISE MADE AVAILABLE TO ANY  *
**  OTHER PERSON.  NO TITLE TO AND OWNERSHIP OF  THE  SOFTWARE  IS  HEREBY  *
**  TRANSFERRED.                                                            *
**                                                                          *
**  THE INFORMATION IN THIS SOFTWARE IS SUBJECT TO CHANGE  WITHOUT  NOTICE  *
**  AND  SHOULD  NOT  BE  CONSTRUED  AS  A COMMITMENT BY DIGITAL EQUIPMENT  *
**  CORPORATION.                                                            *
**                                                                          *
**  DIGITAL ASSUMES NO RESPONSIBILITY FOR THE USE OR  RELIABILITY  OF  ITS  *
**  SOFTWARE ON EQUIPMENT WHICH IS NOT SUPPLIED BY DIGITAL.                 *
**                                                                          *
*****************************************************************************
**++
**  FACILITY:
**
**	< to be supplied >
**
**  ABSTRACT:
**
**	< to be supplied >
**
**  ENVIRONMENT:
**
**	< to be supplied >
**
**  MODIFICATION HISTORY:
**
**	< to be supplied >
**
**--
**/

#ifndef _XtCompositeP_h
#define _XtCompositeP_h

/************************************************************************
 *
 * Additional instance fields for widgets of (sub)class 'Composite' 
 *
 ************************************************************************/

typedef Cardinal (*XtOrderProc)();
    /* Widget child; */

typedef struct _CompositePart {
    WidgetList  children;	     /* array of ALL widget children	     */
    Cardinal    num_children;	     /* total number of widget children	     */
    Cardinal    num_slots;           /* number of slots in children array    */
    Cardinal    num_mapped_children; /* count of managed and mapped children */
    XtOrderProc insert_position;     /* compute position of new child	     */
} CompositePart;

typedef struct _CompositeRec {
    CorePart      core;
    CompositePart composite;
} CompositeRec;

/*********************************************************************
 *
 *  Additional class fields for widgets of (sub)class 'Composite'
 *
 ********************************************************************/

typedef struct _CompositeClassPart {
    XtGeometryHandler geometry_manager;	  /* geometry manager for children   */
    XtWidgetProc      change_managed;	  /* change managed state of child   */
    XtArgsProc	      insert_child;	  /* physically add child to parent  */
    XtWidgetProc      delete_child;	  /* physically remove child	     */
    XtWidgetProc      move_focus_to_next; /* move Focus to next child	     */
    XtWidgetProc      move_focus_to_prev; /* move Focus to previous child    */
} CompositeClassPart;

typedef struct _CompositeClassRec {
     CoreClassPart      core_class;
     CompositeClassPart composite_class;
} CompositeClassRec;

globalref CompositeClassRec compositeClassRec;

extern XtGeometryResult XtInheritGeometryManager();
extern void XtInheritChangeManaged ();
extern void XtInheritInsertChild ();
extern void XtInheritDeleteChild ();
extern void XtInheritMoveFocusToNext ();
extern void XtInheritMoveFocusToPrev ();

#endif _XtCompositeP_h
/* DON'T ADD STUFF AFTER THIS #endif */
