/*  DEC/CMS REPLACEMENT HISTORY, Element COREP.H */
/*   6    31-MAR-1988 12:01:10 TREGGIARI "MARCH 30 INTRINSICS" */
/*   5    25-MAR-1988 09:09:30 TREGGIARI "Make _XtInheritTranslations a globaldef" */
/*   4    24-MAR-1988 15:45:18 TREGGIARI "Replace with completely new version" */
/*  *3    27-FEB-1988 18:17:18 GEORGE "Add copyright" */
/*  *2     5-JAN-1988 15:35:04 TREGGIARI "Replace with completely new version" */
/*  *1    18-DEC-1987 14:02:56 TREGGIARI "Initial Entry" */
/*  DEC/CMS REPLACEMENT HISTORY, Element COREP.H */
/*
* $Header: CoreP.h,v 6.12 87/12/31 18:13:14 chow Exp $
*/

/*
*****************************************************************************
**                                                                          *
**                         COPYRIGHT (c) 1988 BY                            *
**             DIGITAL EQUIPMENT CORPORATION, MAYNARD, MASS.                *
**			   ALL RIGHTS RESERVED                              *
**                                                                          *
**  THIS SOFTWARE IS FURNISHED UNDER A LICENSE AND MAY BE USED AND  COPIED  *
**  ONLY  IN  ACCORDANCE  WITH  THE  TERMS  OF  SUCH  LICENSE AND WITH THE  *
**  INCLUSION OF THE ABOVE COPYRIGHT NOTICE.  THIS SOFTWARE OR  ANY  OTHER  *
**  COPIES  THEREOF MAY NOT BE PROVIDED OR OTHERWISE MADE AVAILABLE TO ANY  *
**  OTHER PERSON.  NO TITLE TO AND OWNERSHIP OF  THE  SOFTWARE  IS  HEREBY  *
**  TRANSFERRED.                                                            *
**                                                                          *
**  THE INFORMATION IN THIS SOFTWARE IS SUBJECT TO CHANGE  WITHOUT  NOTICE  *
**  AND  SHOULD  NOT  BE  CONSTRUED  AS  A COMMITMENT BY DIGITAL EQUIPMENT  *
**  CORPORATION.                                                            *
**                                                                          *
**  DIGITAL ASSUMES NO RESPONSIBILITY FOR THE USE OR  RELIABILITY  OF  ITS  *
**  SOFTWARE ON EQUIPMENT WHICH IS NOT SUPPLIED BY DIGITAL.                 *
**                                                                          *
*****************************************************************************
**++
**  FACILITY:
**
**	< to be supplied >
**
**  ABSTRACT:
**
**	< to be supplied >
**
**  ENVIRONMENT:
**
**	< to be supplied >
**
**  MODIFICATION HISTORY:
**
**	< to be supplied >
**
**--
**/

#ifndef XtCoreP_h
#define XtCoreP_h
typedef struct _StateRec *StatePtr;

typedef struct _TMRec {
    XtTranslations   translations; /* private to Translation Manager    */
    XtActionProc*   proc_table;         /* procedure bindings for actions    */
    StatePtr        current_state;      /* Translation Manager state ptr     */
    unsigned long   lastEventTime;
} TMRec;


/***************************************************************
 * Widget Core Data Structures
 *
 *
 **************************************************************/

typedef struct _CorePart {
    Widget	    self;		/* pointer to widget itself	     */
    WidgetClass	    widget_class;	/* pointer to Widget's ClassRec	     */
    Widget	    parent;		/* parent widget	  	     */
    String          name;		/* widget resource name		     */
    XrmName         xrm_name;		/* widget resource name quarkified   */
    Screen	    *screen;		/* window's screen		     */
    Colormap        colormap;           /* colormap                          */
    Window	    window;		/* window ID			     */
    Position        x, y;		/* window position		     */
    Dimension       width, height;	/* window dimensions		     */
    Cardinal        depth;		/* number of planes in window        */
    Dimension       border_width;	/* window border width		     */
    Pixel	    border_pixel;	/* window border pixel		     */
    Pixmap          border_pixmap;	/* window border pixmap or NULL      */
    Pixel	    background_pixel;	/* window background pixel	     */
    Pixmap          background_pixmap;	/* window background pixmap or NULL  */
    struct _XtEventRec *event_table;	/* private to event dispatcher       */
    struct _TMRec   tm;                 /* translation management            */
    caddr_t         constraints;        /* constraint record                 */
    Boolean         visible;		/* is window mapped and not occluded?*/
    Boolean	    sensitive;		/* is widget sensitive to user events*/
    Boolean         ancestor_sensitive;	/* are all ancestors sensitive?      */
    Boolean         managed;		/* is widget geometry managed?	     */
    Boolean	    mapped_when_managed;/* map window if it's managed?       */
    Boolean         being_destroyed;	/* marked for destroy		     */
    XtCallbackList  destroy_callbacks;	/* who to call when widget destroyed */
    WidgetList      popup_list;         /* list of popups */
    Cardinal        num_popups;         /* how many popups */
} CorePart;

typedef struct _WidgetRec {
    CorePart    core;
 } WidgetRec;



/******************************************************************
 *
 * Core Class Structure. Widgets, regardless of their class, will have
 * these fields.  All widgets of a given class will have the same values
 * for these fields.  Widgets of a given class may also have additional
 * common fields.  These additional fields are included in incremental
 * class structures, such as CommandClass.
 *
 * The fields that are specific to this subclass, as opposed to fields that
 * are part of the superclass, are called "subclass fields" below.  Many
 * procedures are responsible only for the subclass fields, and not for
 * any superclass fields.
 *
 ********************************************************************/

typedef struct _CoreClassPart {
    WidgetClass     superclass;		/* pointer to superclass ClassRec   */
    String          class_name;		/* widget resource class name       */
    Cardinal        widget_size;	/* size in bytes of widget record   */
    XtProc	    class_initialize;   /* class initialization proc	    */
    Boolean         class_inited;       /* has class been initialized?      */
    XtInitProc      initialize;		/* initialize subclass fields       */
    XtArgsProc      initialize_hook;    /* notify that initialize called    */
    XtRealizeProc   realize;		/* XCreateWindow for widget	    */
    XtActionList    actions;		/* widget semantics name to proc map */
    Cardinal	    num_actions;	/* number of entries in actions     */
    XtResourceList  resources;		/* resources for subclass fields    */
    Cardinal        num_resources;      /* number of entries in resources   */
    XrmClass        xrm_class;		/* resource class quarkified	    */
    Boolean         compress_motion;    /* compress MotionNotify for widget */
    Boolean         compress_exposure;  /* compress Expose events for widget*/
    Boolean         compress_enterleave;/* compress enter and leave events  */
    Boolean         visible_interest;   /* select for VisibilityNotify      */
    XtWidgetProc    destroy;		/* free data for subclass pointers  */
    XtWidgetProc    resize;		/* geom manager changed widget size */
    XtExposeProc    expose;		/* rediplay window		    */
    XtSetValuesFunc set_values;		/* set subclass resource values     */
    XtArgsFunc      set_values_hook;    /* notify that set_values called    */
    XtAlmostProc    set_values_almost;  /* set_values got "Almost" geo reply */
    XtArgsProc      get_values_hook;    /* notify that get_values called    */
    XtWidgetProc    accept_focus;      /* assign input focus to widget      */
    XtVersionType   version;	       /* version of intrinsics used	    */
    struct _XtOffsetRec *callback_private;/* list of callback offsets       */
    String         tm_table;          /* state machine                      */
  } CoreClassPart;

typedef struct _WidgetClassRec {
    CoreClassPart core_class;
} WidgetClassRec;

globalref WidgetClassRec widgetClassRec;

extern int _XtInheritTranslations;
#define XtInheritTranslations  ((String) &_XtInheritTranslations)
extern void XtInheritRealize ();
extern void XtInheritResize ();
extern void XtInheritExpose ();
extern void XtInheritSetValuesAlmost();
extern void XtInheritAcceptFocus ();

#endif _XtCoreP_h
/* DON'T ADD STUFF AFTER THIS #endif */
